<?php
/*ARTURO: Codigo para la Creacion de un custom type para ABM de paypals EN HIJO*/
/* 1 Creación del usuario supervisor*/
/* 3.- Agregar un listener para paypal checkout*/
/* 7.- Crear una page de redireccion (En tema hijo pais)*/


/**
 * 1.- Creación del usuario supervision por una sola vez
 */
function usuariopaypal2(){
	$blog_id = get_current_blog_id();
	$user_id = username_exists('supervision');

	if ( $user_id && ! is_user_member_of_blog( $user_id, $blog_id ) ) {
		//Exist's but is not user of the current blog id
		$result = add_user_to_blog( $blog_id, $user_id, 'shop_supervisor' );
	}

	$user_id = username_exists('despacho');

	if ( $user_id && ! is_user_member_of_blog( $user_id, $blog_id ) ) {
		//Exist's but is not user of the current blog id
		$result = add_user_to_blog( $blog_id, $user_id, 'shop_supervisor' );
	}

	$user = wp_get_current_user();
	$role = $user->roles;

}// fin funcion usuariopaypal2

add_action( 'admin_init', 'usuariopaypal2' );

/*3.- Agregar un listener para paypal checkout*/

function mi_script1() 
{
	$opt = get_option( '_invoices_options' );
	$subd=$opt{'subdirectorio'};
	$ruta=$_SERVER['HTTP_HOST'].$subd.get_blog_details()->path;
	echo '
	<script type="text/javascript">
		//*ppcp-merchant_email_production* es el nombre y id del input que al hacer clic abrirá una ventana emergente vinculada desde donde se seleccionará el paypal.
		var el = document.getElementById("ppcp-merchant_email_production");
		el.addEventListener("click", (event) => {
			//listapaypals es el permalink de una pagina que se debe crear y añadir el shortcode [paypals]
			//La pagina debe ser configurada con un template de ancho completo, si no existiere, crear uno en wp-content/themes/nombredeltema/page-templates/nombretemplate.php
			window.open("https://'.$ruta.'listapaypals", "Seleccionar paypals", "toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1,width=700,height=400,left = 890,top = 500");
			}
		);
	</script>';
}

add_action( 'admin_footer', 'mi_script1' );

/*4.- Crear un shortcode 'paypals'*/

function funcion_paypals() {
	if(current_user_can('ver_paypals')){
		global $wpdb;
		$sites = get_sites();
		$blogorig_id = get_current_blog_id();
		foreach ( $sites as $site ) {
			switch_to_blog( $site->blog_id );
			$opt = get_option( '_invoices_options' );
			if($opt['padrehijo']=="Q"){

				$totalq="SELECT COUNT(ID) FROM {$wpdb->prefix}posts WHERE post_status='publish' AND post_type='paypalpayments'";
				$total=$wpdb->get_var($totalq);

				$args = array(
				'posts_per_page'   => $total,
				'offset'           => 0,
				'category'         => '',
				'orderby'          => 'post_title',
				'order'            => 'ASC',
				'post_type'        => 'paypalpayments',
				'post_status'      => 'publish',
				'suppress_filters' => true ); 
				$paypls = get_posts($args);
				$tabla.="<h3 style='text-align:center;'>SELECCIONE UN PAYPAL.</h3>";
				$tabla.="<table class='wp-list-table striped' align='center' width='350px'>";
				$tabla.="<tr><td  align='right' width='10%'>NR.</td><td align='center' width='80%'>NOMBRE PAYPAL</td><td width='10%'>AMOUNT</td></tr>";
				$scripts="";
				$i=1;
				foreach ($paypls as $paypl){
					$id =$paypl->ID;
					$sites=get_post_meta($id,'_forsites');
					if ($sites<>false){
						if(in_array($blogorig_id,$sites[0])){
							$liveEmailAddress=get_post_meta($id,'_liveEmailAddress');
							$liveMerchantId=get_post_meta($id,'_liveMerchantId');
							$liveClientId=get_post_meta($id,'_liveClientId');
							$liveSecretKey=get_post_meta($id,'_liveSecretKey');
							$ppcategory=get_post_meta($id,'_ppcategory');
							$ppdaysales=get_post_meta($id,'_ppdaysales');
							$pplifetimesales=get_post_meta($id,'_pplifetimesales');

							$EmailAddress=$liveEmailAddress[0];
							$MerchantId=$liveMerchantId[0];
							$ClientId=$liveClientId[0];
							$SecretKey=$liveSecretKey[0];

							$tabla.="<tr><td align='right'><input style='width:30px;' readonly value='".$i++."'></td>";
							$tabla.="<td align='center'>".paypal_color_span($ppcategory[0])."<input id='in_".$id."' name='in_".$id."' readonly value='".$paypl->post_title."'></td>";
							$tabla.="<td><input style='width:60px;' id='in_".$id."' name='amount_".$id."' readonly value='".$pplifetimesales[0]."'></td>";
							$tabla.="</tr>";
							$scripts.="var el = document.getElementById('in_".$id."');
								el.addEventListener('click', (event) => {
								window.opener.document.getElementsByName('ppcp[merchant_email_production]')[0].value='".$EmailAddress."';//TextBox1 is in parent page
								window.opener.document.getElementsByName('ppcp[merchant_id_production]')[0].value='".$MerchantId."';//TextBox1 is in parent page
								window.opener.document.getElementsByName('ppcp[client_id_production]')[0].value='".$ClientId."';//TextBox1 is in parent page
								window.opener.document.getElementsByName('ppcp[client_secret_production]')[0].value='".$SecretKey."';//TextBox1 is in parent page
								window.close();
								},true
								);";
						}//if in array blog id END
					}//if isset sites END
				}//foreach pappls as paypl END
				$tabla.="</table>";
				$url="https://".$_SERVER['SERVER_NAME']."/wp-admin/edit.php?post_type=paypals";
				//$tabla.="<br><p style='text-align:right'><a href='".$url."'>AÑADIR/MODIFICAR/BORRAR PAYPALS</a></p>";
				$tabla.= "<script type='text/javascript'>";
				$tabla.=$scripts;
				$tabla.= "</script>";
			}//fin de if opt padrehijo
			restore_current_blog();
		}//fin de foreach
    }else{
		$tabla = '<meta http-equiv="refresh" content="2;URL=/shop">';
    }
	return $tabla;
}

add_shortcode('paypals','funcion_paypals');

/*6.- Crear una page 'listapaypals' (Si no existe)*/
function lista_paypals_page(){
	$blogorig_id = get_current_blog_id();
	$args = array(
		'post_title'	=> 'listapaypals'
	);
	$my_posts = get_posts( $args );
	if(empty($my_posts))
	{
		$parametros=array(
		'ID'=>'',
		'post_author'=>$user->ID,
		'post_content'=>'[paypals]',
		'post_title'=>'listapaypals',
		'post_name'=>'listapaypals',
		'post_status'=>'publish',
		'post_type'=>'page'
		);
		$post_id = wp_insert_post($parametros);
		add_post_meta($post_id, '_wp_page_template', 'paypals_template.php', true);
	}// Fin de empty
	
}

//add_action( 'admin_init', 'lista_paypals_page' );


/*7.- Crear una page de redireccion (En tema hijo pais)*/

function add_the_theme_page(){
	add_menu_page('Paypals', 'Paypals', 'ver_paypals', 'theme-options', 'page_content', 'dashicons-admin-post',27);
}
add_action('admin_menu', 'add_the_theme_page');
function page_content(){
	$opt = get_option( '_invoices_options' );
	$subd=$opt{'subdirectorio'};
	$ruta1=$_SERVER['HTTP_HOST'].$subd.get_blog_details()->path;
	$sites = get_sites();
	$blogorig_id = get_current_blog_id();
	foreach ( $sites as $site ) {
		switch_to_blog( $site->blog_id );
		$opt = get_option( '_invoices_options' );
		if($opt['padrehijo']=="Q"){
			$ruta=$_SERVER['HTTP_HOST'].$subd.get_blog_details()->path;
		}
	}
	restore_current_blog();
	echo '<br><br><h4>El siguiente enlace redirige a la administracion general de paypals del sitio principal de esta tienda.</h4>';
	echo '<div><h2><a href="https://'.$ruta.'wp-admin/edit.php?post_type=paypalpayments" target="_blank">Clic aqui para añadir o modificar paypalpyments</a></h2></div>';
	echo '<h4>Tome en cuenta que la tabla de paypals se administra de forma centralizada en la tienda principal.</h4>';
	echo '<h4>La selección de cuenta paypal en las tiendas por pais se realiza en: <a href="https://'.$ruta1.'wp-admin/admin.php?page=wc-settings&tab=checkout&section=ppcp-gateway&ppcp-tab=ppcp-connection">woocommerce/Settings/Payments/Paypal/Connection</a> de la tienda, del pais.</h4>';
}
/*FIN DE: Codigo para la Creacion de un custom type para ABM de paypals*/
include("paypal-common-functions.php");
