<?php
/*
Description: Mostrar dashboard Widget con los paypals
Version: 1.2 (No mostrar tiendas no activas en el dashboard ni manuals)
Author: Arturo
License: GPLv2 or later
*/

defined( 'ABSPATH' ) || exit;

//Accion Hook Red
add_action('wp_network_dashboard_setup','agregar_widget_red');
//add_action('wp_dashboard_setup','dcms_agregar_widget');

//Agregar Widget de red
function agregar_widget_red(){
	wp_add_dashboard_widget('id_mi_widget','Active Paypals for all sites','mostrar_widget_red');
}

function mostrar_widget_red(){

	//$url="https://arturo.softwarelicenses.net/ppjsonreturn/?pp_table_or_widget=T&pp_method=checkout"; // url de la pagina que queremos obtener  
	//$url_content = '';  
	//$file = @fopen($url, 'r');  
	//if($file){  
	//  while(!feof($file)) {  
	//	$url_content .= @fgets($file, 4096);  
	//  }  
	//  fclose ($file);  
	//}  
	//$r = json_decode($url_content);
	//$filas=json_decode($url_content);
	switch_to_blog($GLOBALS['pp_server_id']);
    $options = get_option( '_paypal_options' );
	restore_current_blog();
	$columna = $options['periodsales'];
	$filas = json_decode(paypal_return_paypals_table('W'));
	switch($columna){//A=active D=daily M=monthly L=lifetime
		case 'A':
			$title_column="SINCE ACTIVE SALES";
			break;
		case 'D':
			$title_column="TODAY SALES";
			break;
		case 'M':
			$title_column="MONTHLY SALES";
			break;
		case 'L':
			$title_column="LIFETIME SALES";
			break;
	}
	$mostrar="<table border=1 style='border-collapse: collapse;' width='100%'>";
	$mostrar.="<tr style='background-color:#f2f2f2;text-align:center;'><td>SITE NAME</td><td>PAYPAL</td><td width='50px'>".$title_column."</td></tr>";
	foreach ($filas as $fila){
		switch($columna){//A=active D=daily M=monthly L=lifetime
			case 'A':
				$value_column=$fila->ppactivesales;
				break;
			case 'D':
				$value_column=$fila->ppdaysales;
				break;
			case 'M':
				$value_column=$fila->ppmonthlysales;
				break;
			case 'L':
				$value_column=$fila->pplifetimesales;
				break;
		}
		$mostrar.="<tr>";
			$mostrar.="<td><span> ".$fila->sitio."</span></td><td><div style='color:red;font-size:16px;'>".$fila->pp_user_name."</div>".$fila->colorcod."&nbsp;&nbsp;Changed on: ".$fila->pp_date_changed."</td><td align='center'><b>".$value_column."</b></td>";
		$mostrar.="</tr>";
	}
	$mostrar.="</table>";
	echo $mostrar;
}

//Accion Hook por pais
add_action('wp_dashboard_setup','agregar_widget_pais');

//Agregar Widget por pais
function agregar_widget_pais(){
	wp_add_dashboard_widget('id_mi_widget','Active Paypal for this site','mostrar_widget_pais');
}

//Mostrar Widget por pais
function mostrar_widget_pais(){

	$fila1 = json_decode(paypal_return_paypals_table('P'));
	$fila=$fila1[0];

	switch_to_blog($GLOBALS['pp_server_id']);
		$options = get_option( '_paypal_options' );
	restore_current_blog();
	$columna = $options['periodsales'];
	$filas = json_decode(paypal_return_paypals_table('W'));
	switch($columna){//A=active D=daily M=monthly L=lifetime
		case 'A':
			$title_column="SINCE ACTIVE SALES";
			$value_column=$fila->ppactivesales;
			break;
		case 'D':
			$title_column="TODAY SALES";
			$value_column=$fila->ppdaysales;
			break;
		case 'M':
			$title_column="MONTHLY SALES";
			$value_column=$fila->ppmonthsales;
			break;
		case 'L':
			$title_column="LIFETIME SALES";
			$value_column=$fila->pplifetimesales;
			break;
	}


//print_r($fila);
	echo "<div>Paypal receiver active is: <div style='color:red;font-size:20px'>".$fila->colorcod."&nbsp;&nbsp;".$fila->pp_user_name."</div><hr>
	<div style='color:blue;font-size:15px;float:left;'>Since: ".$fila->pp_date_changed."</div><div style='text-align:right;'>".$title_column.": <b style='font-size:18px;'>".$value_column."</b></div></div>";	
}// fin de funcion


